10 REM  ***********************************************
20 REM  ***********************************************
30 REM  **
40 REM  **       EPSON MX-80 PLOTTING PROGRAM
50 REM  **
60 REM  ***********************************************
70 REM  ***********************************************
80 REM
90 REM
100 REM  ***********************************************
110 REM  * ENTER DATA FROM DISK FILE W/OPTIONAL PRINTOUT
120 REM  ***********************************************
130 REM
140 DIM X(101),Y(101)
150 INPUT "WHAT IS DESIGNATION OF DATA FILE? ";DAT$
160 OPEN "I",1,DAT$
170 FOR I=1 TO 101
180 INPUT #1,X(I),Y(I)
190 ON ERROR GOTO 210
200 NEXT I
210 CLOSE #1
220 INPUT "DO YOU WANT TO LIST THE DATA ?--(Y)ES/(N)O";L$
230 IF LEFT$(L$,1)="Y" THEN 240 ELSE 340
240 LPRINT CHR$(12)
250 LPRINT :LPRINT :LPRINT "         DATA":LPRINT 
260 LPRINT "   X               Y":LPRINT 
270 FOR I=1 TO 101
280 LPRINT X(I),Y(I)
290 ON ERROR GOTO 340
300 NEXT I
310 LPRINT CHR$(12)
320 REM
330 REM
340 REM  ***********************************************
350 REM  *     PLOT PROGRAM FOR MX-80 PRINTER
360 REM  *  BY L. J. BERGOLI--BYTE MARCH, 1982
370 REM  * (MODIFICATIONS TO DATA INPUT-LINES TO 1300)
380 REM  ***********************************************
390 REM
400 REM  ***********************************************
410 REM  *  ENTER TITLE OF PLOT AND AXIS TITLES
420 REM  ***********************************************
430 REM
440 XTITLE$=SPACE$(50):YTITLE$=SPACE$(50):PTITLE$=SPACE$(50)
450 LINE INPUT "ENTER TITLE OF PLOT (50 CHAR OR LESS) ";T$
460 LINE INPUT "ENTER Y AXIS TITLE (50 CHAR OR LESS) ";Y$
470 LINE INPUT "ENTER X AXIS TITLE (50 CHAR OR LESS) ";X$
480 MID$(YTITLE$,(LEN(YTITLE$)-LEN(Y$))/2)=Y$
490 MID$(XTITLE$,(LEN(XTITLE$)-LEN(X$))/2)=X$
500 MID$(PTITLE$,(LEN(PTITLE$)-LEN(T$))/2)=T$
510 INPUT "DO YOU WANT (A)UTO OR (M)ANUAL SCALING? ";Y$
520 IF Y$="M" THEN 550
530 IF Y$="A" THEN GOSUB 1820 ELSE 510
540 GOTO 690
550 INPUT "ENTER MAXIMUM VALUE OF Y AXIS";YMAX
560 INPUT "ENTER MINIMUN VALUE OF Y AXIS";YMIN
570 INPUT "ENTER MAXIMUM VALUE OF X AXIS";XMAX
580 INPUT "ENTER MINIMUM VALUE OF X AXIS";XMIN
590 REM
600 REM  ***********************************************
610 REM  *  MAIN BODY OF PROGRAM STARTS HERE
620 REM  ***********************************************
630 REM
640 REM 
650 REM  ***********************************************
660 REM  *  SPEED UP MODIFICATIONS USING SORT ROUTINE
670 REM  ***********************************************
680 REM
690 LPRINT :LPRINT :LPRINT TAB(15);PTITLE$:REM
700 TOP=100:TEMPTOP=100
710 GOSUB 2160:REM
720 LPRINT :LPRINT 
730 GOSUB 1060:REM
740 LSPACE=2:GOSUB 1030:REM
750 RSTOP=20:CHAR$="|":GOSUB 1100:REM
760 FOR LNNO=100 TO 0 STEP -1
770 YN=YMAX-(((YMAX-YMIN)/100)*(100-LNNO)):REM
780 YD=ABS((YMAX-YMIN)/100):REM
790 GOSUB 1520:REM
800 IF LNNO/2-FIX(LNNO/2)=0 THEN GOSUB 1160:REM
810 GOSUB 1270:REM
820 GOSUB 1410:REM
830 LPRINT 
840 RSTOP=20:CHAR$="|":GOSUB 1100:REM
850 LPRINT 
860 NEXT LNNO
870 GOSUB 1620:REM
880 GOSUB 1730:REM
890 LSPACE=12:GOSUB 1030:REM
900 GOSUB 1080:REM
910 FOR I=1 TO 23:LPRINT :NEXT I:REM
920 END
930 REM
940 REM  ***********************************************
950 REM  * END OF MAIN BODY-SUBROUTINES START HERE
960 REM  ***********************************************
970 REM
980 REM
990 REM  ***********************************************
1000 REM  *   PRINTER CONTROL SUBROUTINES
1010 REM  ***********************************************
1020 REM
1030 LPRINT CHR$(27)"A"CHR$(LSPACE)CHR$(27)"2":REM
1040 RETURN:REM
1050 REM
1060 LPRINT CHR$(15):RETURN:REM
1070 REM
1080 LPRINT CHR$(18):RETURN:REM
1090 REM
1100 LPRINT SPC(RSTOP);CHAR$;:RETURN:REM
1110 REM
1120 REM  ***********************************************
1130 REM  *  PLOT VERTICAL LINE SUBROUTINE
1140 REM  ***********************************************
1150 REM
1160 CHAR$="|":RSTOP=20:LPRINT CHR$(13);:GOSUB 1100
1170 RSTOP=9
1180 FOR I=1 TO 10
1190 GOSUB 1100
1200 NEXT I
1210 RETURN
1220 REM
1230 REM  ***********************************************
1240 REM  *  PLOT SORTED DATA SUBROUTINE
1250 REM  ***********************************************
1260 REM
1270 CHAR$="0"
1280 FOR I=TOP TO 0 STEP -1
1290 IF Y(I)>YN+.50001*YD THEN 1350
1300 IF Y(I)<YN-.5*YD THEN I=0:GOTO 1350
1310 TEMPTOP=I
1320 XP=FIX((X(I)-XMIN)*100/(XMAX-XMIN))
1330 IF XP<0 OR XP>100 THEN 1350
1340 LPRINT CHR$(13);:RSTOP=XP+20:GOSUB 1100
1350 NEXT I:TOP=TEMPTOP:RETURN
1360 REM
1370 REM  ***********************************************
1380 REM  * PLOT Y SCALE AND HORIZONTAL LINE SUBROUTINE
1390 REM  ***********************************************
1400 REM
1410 IF LNNO/10-FIX(LNNO/10)<>0 THEN RETURN
1420 LPRINT CHR$(13);:RSTOP=10:CHAR$=" ":GOSUB 1100
1430 LPRINT USING "######.##";(YMAX-YMIN)*LNNO/100+YMIN
1440 LPRINT CHR$(13);:RSTOP=20:CHAR$="-":GOSUB 1100
1450 LPRINT STRING$(100,"-");
1460 RETURN
1470 REM
1480 REM  ***********************************************
1490 REM  *   PRINT Y-AXIS TITLE
1500 REM  ***********************************************
1510 REM
1520 IF LNNO/2-FIX(LNNO/2)<>0 THEN RETURN
1530 LPRINT CHR$(13);:RSTOP=7
1540 CHAR$=MID$(YTITLE$,FIX(((100-LNNO)/2)+1),1)
1550 GOSUB 1100
1560 RETURN
1570 REM
1580 REM  ***********************************************
1590 REM  *   PRINT X SCALE SUBROUTINE
1600 REM  ***********************************************
1610 REM
1620 LPRINT :LPRINT 
1630 RSTOP=13:CHAR$=" ":GOSUB 1100
1640 FOR I=0 TO 10
1650 LPRINT USING "#######.##";(XMAX-XMIN)*I/10+XMIN;
1660 NEXT I
1670 RETURN
1680 REM
1690 REM  ***********************************************
1700 REM  *   PRINT X-AXIS TITLE
1710 REM  ***********************************************
1720 REM
1730 LPRINT :LPRINT :LPRINT 
1740 LPRINT :LPRINT :LPRINT 
1750 RSTOP=45:CHAR$=XTITLE$:GOSUB 1100
1760 RETURN
1770 REM
1780 REM  ***********************************************
1790 REM  *    AUTO-SCALING SUBROUTINES
1800 REM  ***********************************************
1810 REM
1820 YMAX=Y(0):XMAX=X(0):YMIN=Y(0):XMIN=X(0)
1830 FOR I=1 TO 100:REM
1840 IF Y(I)>YMAX THEN YMAX=Y(I)
1850 IF Y(I)<YMIN THEN YMIN=Y(I)
1860 IF X(I)>XMAX THEN XMAX=X(I)
1870 IF X(I)<XMIN THEN XMIN=X(I)
1880 NEXT I
1890 RESTORE 2100
1900 MSD=(YMAX-YMIN)/10:REM
1910 FOR I=-2 TO 4
1920 FOR K=1 TO 3:READ J
1930 IF MSD<=J*10^(I) THEN MSD=J*10^(I):GOTO 1950
1940 NEXT K:RESTORE 2100:NEXT I
1950 FOR I=10 TO -10 STEP -1
1960 IF (YMAX<=I*MSD)*(YMAX>I*MSD-.99999*MSD) THEN YMAX=I*MSD
1970 NEXT I
1980 YMIN=YMAX-10*MSD
1990 RESTORE 2100:REM
2000 MSD=(XMAX-XMIN)/10:REM
2010 FOR I=-2 TO 4
2020 FOR K=1 TO 3:READ J
2030 IF MSD<=J*10^(I) THEN MSD=J*10^(I):GOTO 2050
2040 NEXT K:RESTORE 2100:NEXT I
2050 FOR I=10 TO -10 STEP-1
2060 IF (XMAX<=I*MSD)*(XMAX>I*MSD-.99999*MSD) THEN XMAX=I*MSD
2070 NEXT I
2080 XMIN=XMAX-10*MSD
2090 RETURN
2100 DATA 1,2,5
2110 REM
2120 REM  ***********************************************
2130 REM  *    SHELL SORT OF DATA
2140 REM  ***********************************************
2150 REM
2160 M=100
2170 REM
2180 M=INT(M/2):IF M=0 THEN RETURN
2190 J=0:K=100-M
2200 I=J
2210 L=I+M:IF Y(I)<Y(L) THEN 2240
2220 T=Y(I):T1=X(I):Y(I)=Y(L):X(I)=X(L):Y(L)=T:X(L)=T1:I=I-M
2230 IF I<0 THEN 2240 ELSE 2210
2240 J=J+1:IF J<=K THEN 2200 ELSE 2180
2250 REM
2260 REM  ***********************************************
2270 REM  * LIST OF VARIABLE NAMES USED IN PROGRAM
2280 REM  ***********************************************
2290 REM
2300 REM   Y(I)       Y-AXIS DATA
2310 REM   X(I)       X-AXIS DATA
2320 REM   YMAX       MAXIMUM VALUE OF Y-AXIS
2330 REM   YMIN       MINIMUM   "   "    "
2340 REM   XMAX       MAXIMUM VALUE OF X-AXIS
2350 REM   XMIN       MINIMUM   "   "    "
2360 REM   LNNO       Y-AXIS LINE NUMBER
2370 REM   RSTOP      CHARACTER TAB STOP
2380 REM   LSPACE     SIZE OF PRINTER LINEFEED
2390 REM   YN         NORMALIZED Y-AXIS VALUE
2400 REM   YD         Y-AXIS DELTA VALUE
2410 REM   XP         CHARACTER POSITION ON X-AXIS
2420 REM   MSD        MINIMUM SCALE DELTA
2430 REM   J          SCALE DELTA
2440 REM   CHAR$      STRING PRINTED AT RSTOP
2450 REM
2460 REM  ***********************************************
2470 REM  ***********************************************
450 REM
2460 REM  *******************************************